package com.yifan.yf_ads.admanager;

import android.app.Activity;

import com.yfanads.android.YFAdsManager;
import com.yfanads.android.utils.YFLog;
import com.yifan.yf_ads.utils.Constants;
import com.yifan.yf_ads.utils.FLog;

import org.json.JSONObject;

import io.flutter.plugin.common.EventChannel;

/**
 * 一句话描述该类功能.
 *
 * @author JamesQian
 * @version 1.0
 * @copyright 亿帆
 * @date 2024/1/25 10:30
 **/
public class CommonAdManager {

    protected AdListener adListener;

    protected Activity activity;

    protected String adType;

    public interface AdListener {
        void onAdClose();

        void onAdLoadSuccess();

        void onAdLoadFail(String errorMessage);
    }

    protected CommonAdManager(Activity activity, String adType) {
        this.activity = activity;
        this.adType = adType;
    }

    public void setAdListener(AdListener adListener) {
        this.adListener = adListener;
    }

    protected boolean isSDKInit(String tag) {
        if (!YFAdsManager.getInstance().isInitSuc()) {
            FLog.e(tag, "AdSDK is not init");
            return false;
        }
        return true;
    }

    protected void callAdClose() {
        if (adListener != null) {
            adListener.onAdClose();
        }
    }

    protected void callAdSuccess() {
        if (adListener != null) {
            adListener.onAdLoadSuccess();
        }
    }

    protected void callAdFail(String errorMessage) {
        if (adListener != null) {
            adListener.onAdLoadFail(errorMessage);
        }
    }

    protected void destroy() {
        adListener = null;
        activity = null;
    }

    protected void callBack(JSONObject jsonObject, EventChannel.EventSink eventSink) {
        try {
            jsonObject.put(Constants.KEY_AD_TYPE, adType);
            eventSink.success(jsonObject.toString());
        } catch (Throwable e) {
            e.printStackTrace();
        }
    }

}
