package com.yifan.yf_ads.views.stream;

import android.app.Activity;
import android.view.View;
import android.view.ViewGroup;
import android.widget.FrameLayout;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;


import com.yifan.yf_ads.admanager.CommonAdManager;
import com.yifan.yf_ads.admanager.StreamAdManager;
import com.yifan.yf_ads.bean.StreamAdBean;
import com.yifan.yf_ads.utils.Constants;
import com.yifan.yf_ads.utils.FLog;

import io.flutter.plugin.common.EventChannel;
import io.flutter.plugin.platform.PlatformView;


public class StreamView implements PlatformView {
    private final String TAG = "StreamView";

    private StreamAdManager streamAdManager;

    @NonNull
    private FrameLayout containerView;

    public StreamView(@NonNull final Activity activity, int id, @Nullable final StreamAdBean creationParams, EventChannel.EventSink eventSink) {
        FLog.i(TAG, "NativeView id = " + id);
        if (creationParams == null) {
            return;
        }
        if (streamAdManager == null) {
            streamAdManager = new StreamAdManager(activity, Constants.AD_TYPE_STREAM);
        }

        containerView = new FrameLayout(activity);

        streamAdManager.setAdListener(new CommonAdManager.AdListener() {
            @Override
            public void onAdClose() {

            }

            @Override
            public void onAdLoadSuccess() {
                streamAdManager.showAds(activity, containerView);
            }

            @Override
            public void onAdLoadFail(String errorMessage) {

            }
        });
        streamAdManager.requestStreamAd(id, creationParams, eventSink);
    }

    @Override
    public View getView() {
        return containerView;
    }

    @Override
    public void dispose() {
        FLog.i(TAG, "dispose");
        releaseAd();
    }

    public void releaseAd() {
        if (streamAdManager != null) {
            streamAdManager.destroy();
        }
    }
}