import 'dart:core';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import 'package:flutter/foundation.dart';
import 'package:yf_ads/callbacks/yf_ads_callback.dart';
import 'package:yf_ads/sizes/yf_ads_banner_android_size.dart';
import 'package:yf_ads/sizes/yf_ads_banner_ios_size.dart';
import 'package:yf_ads/yf_ads.dart';
import 'package:yf_ads/ads/yf_ads_banner_view.dart';

class YFAdsBannerListViewDemo extends StatefulWidget {
  @override
  State<StatefulWidget> createState() {
    return YFAdsBannerListViewDemoState();
  }
}

class YFAdsBannerListViewDemoState extends State<YFAdsBannerListViewDemo> {
  var deletedBannerItem = [];

  void bannerListViewItemCallBack(YFAdsCallBack reaperAdCallBack) {
    print(
        "bannerListViewItemCallBack is ${reaperAdCallBack.method} and viewId is ${reaperAdCallBack.viewId}");
    if (reaperAdCallBack.method == "onDislike" ||
        reaperAdCallBack.method == "WHNewBannerAdClosed") {
      setState(() {
        deletedBannerItem.add(reaperAdCallBack.viewId);
      });
    }
  }

  @override
  Widget build(BuildContext context) {
    var positionId;
    var androidOS = false;
    if (defaultTargetPlatform == TargetPlatform.android) {
      positionId = "b70687e8-1eb8-4615-88df-65858fe70842";
      androidOS = true;
    } else if (defaultTargetPlatform == TargetPlatform.iOS) {
      positionId = "2eb399cceb2b4003ad9fe5942e12b30d";
      androidOS = false;
    }
    return Scaffold(
      appBar: AppBar(
        title: const Text('Banner列表广告'),
      ),
      body: ListView.builder(
        itemBuilder: (BuildContext context, int index) {
          if (kDebugMode) {
            print("YFAdsBannerListViewDemo index is $index");
          }
          if (index % 5 != 0) {
            return Container(
              width: 200,
              height: 50,
              child: Text(
                "我是第$index个item",
                style: TextStyle(fontSize: 18),
              ),
            );
          }
          bool delete = deletedBannerItem.contains(index);
          return delete
              ? Container()
              : YFAdsBannerView(
                  uniqueId: index,
                  onAdCallBack: bannerListViewItemCallBack,
                  topMarginSize: 36,
                  positionId: positionId,
                  cornerSize: 30,
                  showDislike: true,
                  adSizeType: androidOS
                      ? AndroidBannerAdType.AD_SIZE_W600xH260
                      : IOSBannerAdType.AD_SIZE_NEW_H800,
                );
        },
        itemCount: 18,
      ),
    );
  }

  @override
  void dispose() {
    super.dispose();
    print("YFAdsBannerListViewDemo dispose");
    YFAds.instance.clearBannerPageCache();
  }
}
