import 'dart:core';
import 'package:flutter/material.dart';
import 'package:flutter/foundation.dart';
import 'package:yf_ads/callbacks/yf_ads_callback.dart';
import 'package:yf_ads/sizes/yf_ads_banner_android_size.dart';
import 'package:yf_ads/sizes/yf_ads_banner_ios_size.dart';
import 'package:yf_ads/yf_ads.dart';
import 'package:yf_ads/ads/yf_ads_banner_view.dart';

class YFAdsBannerViewDemo extends StatefulWidget {
  @override
  State<StatefulWidget> createState() {
    return YFAdsBannerViewDemoState();
  }
}

class YFAdsBannerViewDemoState extends State<YFAdsBannerViewDemo> {
  bool showBanner = true;

  void bannerViewCallBack(YFAdsCallBack args) {
    print("bannerViewCallBack is ${args.method}");
    if (args.method == "onDislike" || args.method == "WHNewBannerAdClosed") {
      setState(() {
        showBanner = false;
      });
    }
  }

  void reloadBannerAd() {
    print("reloadBannerAd");
    YFAds.instance.clearBannerPageCache();
    setState(() {
      showBanner = true;
    });
  }

  @override
  Widget build(BuildContext context) {
    print("banner view demo build");
    var positionId;
    var androidOS = false;
    if (defaultTargetPlatform == TargetPlatform.android) {
      positionId = "b70687e8-1eb8-4615-88df-65858fe70842";
      // jd
      // positionId = "a6235f84-25b5-44ee-bf39-395ad7fd1850";
      androidOS = true;
    } else if (defaultTargetPlatform == TargetPlatform.iOS) {
      positionId = "2eb399cceb2b4003ad9fe5942e12b30d";
      androidOS = false;
    }

    var reloadBannerView = Align(
        alignment: Alignment.center,
        child: ElevatedButton(
          onPressed: reloadBannerAd,
          child: const Text("加载banner广告"),
        ));

    var bannerAdView = showBanner
        ? YFAdsBannerView(
            // key: Key("$bannerCornerSize"),
            onAdCallBack: bannerViewCallBack,
            topMarginSize: 36,
            positionId: positionId,
            cornerSize: 30,
            adSizeType: androidOS
                ? AndroidBannerAdType.AD_SIZE_W600xH400
                : IOSBannerAdType.AD_SIZE_NEW_H800,
          )
        : reloadBannerView;
    return Scaffold(
      appBar: AppBar(
        title: const Text('Banner广告'),
      ),
      body: bannerAdView,
    );
  }

  @override
  void dispose() {
    super.dispose();
    print("YFAdsBannerViewDemo dispose");
    YFAds.instance.clearBannerPageCache();
  }
}
