import 'dart:core';
import 'package:flutter/material.dart';
import 'package:flutter/foundation.dart';
import 'package:yf_ads/callbacks/yf_ads_express_feed_callback.dart';
import 'package:yf_ads/yf_ads.dart';
import 'package:yf_ads/ads/yf_ads_express_feed_view.dart';

class YFAdsExpressFeedViewDemo extends StatefulWidget {
  @override
  State<StatefulWidget> createState() {
    return YFAdsExpressFeedViewDemoState();
  }
}

class YFAdsExpressFeedViewDemoState extends State<YFAdsExpressFeedViewDemo> {
  bool showExpressFeedAd = true;

  void expressFeedViewCallBack(YFAdsExpressFeedCallBack args) {
    if (!mounted) {
      return;
    }
    print("expressFeedViewCallBack is ${args.method}");
    if (args.method == "onDislike" || args.method == "WHNewBannerAdClosed") {
      setState(() {
        showExpressFeedAd = false;
      });
    }
  }

  void reloadExpressFeedAd() {
    print("reloadExpressFeedAd");
    YFAds.instance.clearExpressFeedPageCache();
    setState(() {
      showExpressFeedAd = true;
    });
  }

  @override
  Widget build(BuildContext context) {
    print("express feed view demo build");
    var positionId;
    if (defaultTargetPlatform == TargetPlatform.android) {
      positionId = "0a29f771-de25-41d6-90e7-1269a6a9d85a";
      // jd
      // positionId = "08f3a964-1dae-4193-9f5a-ba533fc50f39";
    } else if (defaultTargetPlatform == TargetPlatform.iOS) {
      positionId = "ae1caa917bbf483aad9127b613668cac";
    }

    var reloadBannerView = Align(
        alignment: Alignment.center,
        child: ElevatedButton(
          onPressed: reloadExpressFeedAd,
          child: const Text("加载信息流广告"),
        ));

    var expressFeedAdView = showExpressFeedAd
        ? YFAsdExpressFeedView(
            onAdCallBack: expressFeedViewCallBack,
            positionId: positionId,
          )
        : reloadBannerView;
    return Scaffold(
        appBar: AppBar(
          title: const Text('信息流广告'),
        ),
        body: Container(
          margin: const EdgeInsets.only(top: 24),
          child: expressFeedAdView,
        ));
  }

  @override
  void dispose() {
    super.dispose();
    print("YFAdsExpressFeedViewDemo dispose");
    YFAds.instance.clearExpressFeedPageCache();
  }
}
