import 'dart:core';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import 'package:flutter/foundation.dart';
import 'package:yf_ads/callbacks/yf_ads_callback.dart';
import 'package:yf_ads/yf_ads.dart';
import 'package:yf_ads/ads/yf_ads_stream_view.dart';

class YFAdsStreamViewDemo extends StatefulWidget {
  const YFAdsStreamViewDemo({Key? key}) : super(key: key);

  @override
  State<StatefulWidget> createState() {
    return YFAdsStreamViewDemoState();
  }
}

class YFAdsStreamViewDemoState extends State<YFAdsStreamViewDemo> {
  void streamViewCallBack(YFAdsCallBack args) {
    if (!mounted) {
      return;
    }
    print("streamViewCallBack is ${args.method}");
  }

  @override
  Widget build(BuildContext context) {
    print("stream view demo build");
    var positionId;
    if (defaultTargetPlatform == TargetPlatform.android) {
      positionId = "1197365e-a0ab-4f33-ae4c-1e99eec9deaa";
    } else if (defaultTargetPlatform == TargetPlatform.iOS) {
      positionId = "ae1caa917bbf483aad9127b613668cac";
    }

    var streamAdView = YFAdsStreamView(
      height: 300,
      onAdCallBack: streamViewCallBack,
      positionId: positionId,
    );
    return Scaffold(
        appBar: AppBar(
          title: const Text('贴片广告'),
        ),
        body: Container(
          margin: const EdgeInsets.only(top: 24),
          child: streamAdView,
        ));
  }

  @override
  void dispose() {
    super.dispose();
    print("YFAdsStreamViewDemo dispose");
    YFAds.instance.clearStreamPageCache();
  }
}
