//
//  WHNativeView.m
//  BURelyFoundation
//
//  Created by os on 2022/4/7.
//

#import <Foundation/Foundation.h>
#import "YFAdsNativeView.h"
#import "YFAdsNativeManager.h"

@interface YFAdsNativeView ()<YFFlutterNativeViewDelegate>
@property (nonatomic, strong)  UIView *parentView;
@property (nonatomic, strong)  YFAdsNativeManager *whNativeAdManager;
@end

@implementation YFAdsNativeView

- (instancetype)initWithFrame:(CGRect)frame
                    arguments:(NSDictionary *)args
                    eventSink:(FlutterEventSink)flutterEventSink
               viewController:(UIViewController *)viewController{
    if (self = [super init]) {
        _parentView = [[UIView alloc] init];
    }

    _whNativeAdManager = [[YFAdsNativeManager alloc] initWithParams:flutterEventSink viewController:viewController];
    _whNativeAdManager.flutterNativeDelegate = self;
    [_whNativeAdManager showAd:args];
    return self;
}

- (void)handleParentViewClicked:(UITapGestureRecognizer *)recognizer{
    NSLog(@"handleParentViewClicked");
}

/// native广告播放完成
- (void)yfNativeAdPlayFinished{
    NSLog(@"yfNativeAdPlayFinished");
}
/// native广告加载成功
- (void)yfNativeViewLoadSuccess:(UIView *_Nullable)view{
    NSLog(@"yfNativeViewLoadSuccess");
    if(!_parentView){
        return;
    }
    NSArray *childViews = [_parentView subviews];
    if(childViews){
        for(UIView *views in childViews){
            [views removeFromSuperview];
        }
    }
    [_parentView addSubview:view];

}
///native广告加载失败
- (void)yfNativeViewLoadFail:(NSString *_Nullable)stringMessage{
    NSLog(@"yfNativeViewLoadFail %@",stringMessage);
}

///native广告渲染失败
- (void)yfNativeViewRenderFail{
    NSLog(@"yfNativeViewRenderFail");
}

- (UIView*)view {
    return _parentView;
}

- (void)releaseNativeView{
    if(_whNativeAdManager){
        [_whNativeAdManager releaseNativeView];
    }
}

@end
