//
//  yfVideoPathView.m
//  BURelyFoundation
//
//  Created by os on 2022/4/19.
//

#import <Foundation/Foundation.h>
#import "YFAdsVideoView.h"
#import "YFAdsVideoManager.h"

@interface YFAdsVideoView ()<YFFlutterVideoPathViewDelegate>
@property (nonatomic, strong)  UIView *parentView;
@property (nonatomic, strong)  YFAdsVideoManager *yfVideoPathAdManager;
@end

@implementation YFAdsVideoView

- (instancetype)initWithFrame:(CGRect)frame
                    arguments:(NSDictionary *)args
                    eventSink:(FlutterEventSink)flutterEventSink
               viewController:(UIViewController *)viewController{
    if (self = [super init]) {
        _parentView = [[UIView alloc] init];
    }

    _yfVideoPathAdManager = [[YFAdsVideoManager alloc] initWithParams:flutterEventSink viewController:viewController];
    _yfVideoPathAdManager.flutterVideoPathViewDelegate = self;
    [_yfVideoPathAdManager showAd:args];
    return self;
}

- (void)handleParentViewClicked:(UITapGestureRecognizer *)recognizer{
    NSLog(@"handleParentViewClicked");
}

/// 贴片广告点击关闭
- (void)yfVideoPathViewDislike{
    NSLog(@"yfVideoPathViewDislike");
    if(!_parentView){
        return;
    }
    [_parentView removeFromSuperview];
}
/// 贴片广告加载成功
- (void)yfVideoPathViewLoadSuccess:(UIView *_Nullable)view{
    NSLog(@"yfVideoPathViewLoadSuccess");
    if(!_parentView){
        return;
    }
    NSArray *childViews = [_parentView subviews];
    if(childViews){
        for(UIView *views in childViews){
            [views removeFromSuperview];
        }
    }
    [_parentView addSubview:view];

}
///贴片广告加载失败
- (void)yfVideoPathViewLoadFail:(NSString *_Nullable)stringMessage{
    NSLog(@"yfVideoPathViewLoadFail %@",stringMessage);
}

- (UIView*)view {
    return _parentView;
}

@end
