import 'package:yf_ads/bean/yf_ads_native_base_bean.dart';
import 'package:yf_ads/callbacks/yf_ads_callback.dart';

class YFAdsNativeAndroidBean extends YFAdsNativeBaseBean {
  ///自定义视图view id,可以在sdk初始化时传递到flutter代码层
  final int? resourceLayoutId;

  ///整个广告背景圆角大小
  final int? cornerSize;

  ///自定义视图宽度
  final int? containerWidth;

  ///自定义视图高度
  final int? containerHeight;

  const YFAdsNativeAndroidBean(
      {required String positionId,
      int uniqueKey = -1,
      this.containerWidth,
      this.containerHeight,
      this.cornerSize,
      this.resourceLayoutId,
      Function(YFAdsCallBack)? callBack})
      : super(positionId: positionId, uniqueKey: uniqueKey, callBack: callBack);

  YFAdsNativeAndroidBean.fromJson(Map<String, dynamic> json)
      : resourceLayoutId = json['resourceLayoutId'],
        containerWidth = json['containerWidth'],
        containerHeight = json['containerHeight'],
        cornerSize = json['cornerSize'],
        super.fromJson(json, null);

  Map<String, dynamic> toJson() => {
        'containerWidth': containerWidth,
        'containerHeight': containerHeight,
        'positionId': positionId,
        'resourceLayoutId': resourceLayoutId,
        'cornerSize': cornerSize,
        'uniqueKey': uniqueKey,
      };
}
