import 'package:yf_ads/bean/yf_ads_draw_native_express_video_bean.dart';

class YFAdsNativeDrawFeedVideoBean extends YFAdsDrawNativeExpressVideoBean {
  final Function? callBack;
  final bool? interruptVideoPlay;
  final String? pauseIconPath;
  final int? pauseIconResource;
  final int? pauseIconSize;
  final int? drawFeedItemLayoutId;
  final int? drawFeedPageLayoutId;
  final int? gravity;
  final int? topMargin;
  final int? bottomMargin;
  final int? leftMargin;
  final int? rightMargin;

  YFAdsNativeDrawFeedVideoBean.fromJson(
      Map<String, dynamic> json, this.callBack)
      : interruptVideoPlay = json['interruptVideoPlay'],
        pauseIconPath = json['pauseIconPath'],
        pauseIconResource = json['pauseIconResource'],
        pauseIconSize = json['pauseIconSize'],
        drawFeedItemLayoutId = json['drawFeedItemLayoutId'],
        drawFeedPageLayoutId = json['drawFeedPageLayoutId'],
        gravity = json['gravity'],
        topMargin = json['topMargin'],
        bottomMargin = json['bottomMargin'],
        leftMargin = json['leftMargin'],
        rightMargin = json['rightMargin'],
        super.fromJson(json, null);

  const YFAdsNativeDrawFeedVideoBean(
      {required String positionId,
      required int? uniqueKey,
      required double? width,
      required double? height,
      required bool? cache,
      this.interruptVideoPlay,
      this.pauseIconPath,
      this.pauseIconResource,
      this.pauseIconSize,
      this.drawFeedItemLayoutId,
      this.drawFeedPageLayoutId,
      this.gravity,
      this.topMargin,
      this.bottomMargin,
      this.leftMargin,
      this.rightMargin,
      this.callBack})
      : super(
            positionId: positionId,
            width: width,
            height: height,
            cache: cache,
            uniqueKey: uniqueKey);

  Map<String, dynamic> toJson() => {
        'positionId': positionId,
        'uniqueKey': uniqueKey,
        'cache': cache,
        'height': height,
        'width': width,
        'interruptVideoPlay': interruptVideoPlay,
        'pauseIconPath': pauseIconPath,
        'pauseIconResource': pauseIconResource,
        'pauseIconSize': pauseIconSize,
        'drawFeedItemLayoutId': drawFeedItemLayoutId,
        'drawFeedPageLayoutId': drawFeedPageLayoutId,
        'gravity': gravity,
        'topMargin': topMargin,
        'bottomMargin': bottomMargin,
        'leftMargin': leftMargin,
        'rightMargin': rightMargin,
      };
}
