import 'package:yf_ads/bean/yf_ads_native_base_bean.dart';
import 'package:yf_ads/bean/yf_ads_native_ios_view_frame_bean.dart';
import 'package:yf_ads/callbacks/yf_ads_callback.dart';

class YFAdsNativeIosBean extends YFAdsNativeBaseBean {
  ///广告父视图frame
  final YFAdsNativeIOSFrameBean? parentViewFrame;

  ///主图frame
  final YFAdsNativeIOSFrameBean? mainImageViewFrame;

  ///如果广告是三图，第二个图片的frame
  final YFAdsNativeIOSFrameBean? secondImageViewFrame;

  ///如果广告是三图，第三个图片的frame
  final YFAdsNativeIOSFrameBean? thirdImageViewFrame;

  ///广告中title视图frame
  final YFAdsNativeIOSFrameBean? titleViewFrame;

  ///广告中desc视图frame
  final YFAdsNativeIOSFrameBean? descViewFrame;

  ///广告中广告主logo frame
  final YFAdsNativeIOSFrameBean? logoViewFrame;

  ///视频广告视图frame
  final YFAdsNativeIOSFrameBean? mediaViewFrame;

  ///创意可点击按钮背景圆角大小，默认12
  final double? clickButtonCornerRadius;

  ///广告距离顶部距离
  final double? marginTop;

  const YFAdsNativeIosBean(
      {required String positionId,
      int uniqueKey = -1,
      this.parentViewFrame,
      this.mainImageViewFrame,
      this.secondImageViewFrame,
      this.thirdImageViewFrame,
      this.titleViewFrame,
      this.descViewFrame,
      this.logoViewFrame,
      this.mediaViewFrame,
      this.clickButtonCornerRadius,
      this.marginTop,
      Function(YFAdsCallBack)? callBack})
      : super(positionId: positionId, uniqueKey: uniqueKey, callBack: callBack);

  YFAdsNativeIosBean.fromJson(Map<String, dynamic> json)
      : parentViewFrame = json['parentViewFrame'] == null
            ? null
            : YFAdsNativeIOSFrameBean.fromJson(
                json['parentViewFrame'] as Map<String, dynamic>),
        mainImageViewFrame = json['mainImageViewFrame'] == null
            ? null
            : YFAdsNativeIOSFrameBean.fromJson(
                json['mainImageViewFrame'] as Map<String, dynamic>),
        secondImageViewFrame = json['secondImageViewFrame'] == null
            ? null
            : YFAdsNativeIOSFrameBean.fromJson(
                json['secondImageViewFrame'] as Map<String, dynamic>),
        thirdImageViewFrame = json['thirdImageViewFrame'] == null
            ? null
            : YFAdsNativeIOSFrameBean.fromJson(
                json['thirdImageViewFrame'] as Map<String, dynamic>),
        titleViewFrame = json['titleViewFrame'] == null
            ? null
            : YFAdsNativeIOSFrameBean.fromJson(
                json['titleViewFrame'] as Map<String, dynamic>),
        descViewFrame = json['descViewFrame'] == null
            ? null
            : YFAdsNativeIOSFrameBean.fromJson(
                json['descViewFrame'] as Map<String, dynamic>),
        logoViewFrame = json['logoViewFrame'] == null
            ? null
            : YFAdsNativeIOSFrameBean.fromJson(
                json['logoViewFrame'] as Map<String, dynamic>),
        mediaViewFrame = json['mediaViewFrame'] == null
            ? null
            : YFAdsNativeIOSFrameBean.fromJson(
                json['mediaViewFrame'] as Map<String, dynamic>),
        clickButtonCornerRadius = json['clickButtonCornerRadius'],
        marginTop = json['marginTop'],
        super.fromJson(json, null);

  Map<String, dynamic> toJson() => {
        'parentViewFrame': parentViewFrame,
        'mainImageViewFrame': mainImageViewFrame,
        'secondImageViewFrame': secondImageViewFrame,
        'thirdImageViewFrame': thirdImageViewFrame,
        'titleViewFrame': titleViewFrame,
        'descViewFrame': descViewFrame,
        'logoViewFrame': logoViewFrame,
        'mediaViewFrame': mediaViewFrame,
        'clickButtonCornerRadius': clickButtonCornerRadius,
        'positionId': positionId,
        'marginTop': marginTop,
        'uniqueKey': uniqueKey,
      };
}
