import 'package:yf_ads/callbacks/yf_ads_reward_video_callback.dart';

class YFAdsRewardVideoBean {
  static const REWARD_REWARD_VIDEO_VERTICAL = 1;
  static const REWARD_REWARD_VIDEO_HORIZONTAL = 2;

  final String? rewardName;
  final String? userId;
  final int? rewardAmount;
  final String? extra;
  final int? orientation;
  final String? positionId;
  final Function(YFAdsRewardVideoCallBack)? callBack;

  const YFAdsRewardVideoBean(
      {required this.positionId,
      this.extra,
      this.orientation = REWARD_REWARD_VIDEO_VERTICAL,
      this.rewardAmount,
      this.rewardName,
      this.callBack,
      this.userId});

  YFAdsRewardVideoBean.fromJson(Map<String, dynamic> json, this.callBack)
      : rewardName = json['rewardName'],
        userId = json['userId'],
        rewardAmount = json['rewardAmount'],
        extra = json['extra'],
        positionId = json['positionId'],
        orientation = json['orientation'];

  Map<String, dynamic> toJson() => {
        'rewardName': rewardName,
        'userId': userId,
        'positionId': positionId,
        'rewardAmount': rewardAmount,
        'extra': extra,
        'orientation': orientation
      };
}
