import '../callbacks/yf_ads_callback.dart';

class YFAdsSplashBean {
  final String? positionId;

  ///only for android platform usage,for next page after splash ad page finished
  ///if you set it,you should not set splashClassPath or this parameter will ignore.
  final String? destActivityFullPath;

  ///only for android platform usage,you can define it for your own splash ad page
  final String? splashClassPath;

  final Function(YFAdsCallBack)? callBack;


  const YFAdsSplashBean(
      {required this.positionId,
      this.destActivityFullPath,
      this.splashClassPath,this.callBack});

  YFAdsSplashBean.fromJson(Map<String, dynamic> json, this.callBack)
      : positionId = json['positionId'],
        destActivityFullPath = json['destActivityFullPath'],
        splashClassPath = json['splashClassPath'];

  Map<String, dynamic> toJson() => {
        'positionId': positionId,
        'destActivityFullPath': destActivityFullPath,
        'splashClassPath': splashClassPath
      };
}
