import 'package:yf_ads/callbacks/yf_ads_callback.dart';

class YFAdsRewardVideoCallBack extends YFAdsCallBack {
  static const YF_ADS_ON_REWARD_VERIFY = "onRewardVerify";

  final dynamic rewardVerify;

  final String? rewardName;

  final String? rewardInfo;

  const YFAdsRewardVideoCallBack(
      {required String method,
      required String adType,
      required String error,
      required int viewId,
      this.rewardInfo,
      this.rewardVerify,
      this.rewardName})
      : super(method: method, adType: adType, error: error, viewId: viewId);

  YFAdsRewardVideoCallBack.fromJson(Map<String, dynamic> json)
      : rewardVerify = json['reward_verify'],
        rewardName = json['reward_name'],
        rewardInfo = json['reward_info'],
        super.fromJson(json);

  Map<String, dynamic> toJson() => {
        'reward_name': rewardName,
        'reward_info': rewardInfo,
        'method': method,
        'ad_type': adType,
        'error': error,
        'view_id': viewId,
      };
}
