import 'dart:ui';

import 'package:flutter/material.dart';
import 'package:yf_ads/sizes/yf_ads_banner_size.dart';

///
/// 爱奇艺自渲染iOS banner广告大小枚举
///
enum IQYIOSExpressBannerAdType {
  AD_SIZE_FULLIMG, //0
  AD_SIZE_TITLEIN, //1
  AD_SIZE_TITLEAB, //2
  AD_SIZE_TITLEBL, //3
  AD_SIZE_STRIP, //4
}

///
/// 非爱奇艺模板iOS banner广告大小枚举
///
enum IOSExpressBannerAdType {
  AD_SIZE_600X90, //0
  AD_SIZE_640X100, //1
  AD_SIZE_600X150, //2
  AD_SIZE_690X388, //3
  AD_SIZE_600X260, //4
  AD_SIZE_600X300, //5
  AD_SIZE_600X400, //6
  AD_SIZE_600X500, //7
}

///
/// 模板iOS banner广告尺寸处理
///
class IosExpressBannerAdSize extends BannerAdSize {
  ///
  /// aqyAd判断是否是爱奇艺广告
  ///
  @override
  double getHeight(int adSizeIndex, double width, double offset, bool aqyAd) {
    return 0;
  }

  @override
  double getWidth(int adSizeIndex, double screenWidth, double marginSize) {
    return 0;
  }

  Size _getSizeInner(int adSizeIndex, double width, bool aqyAd) {
    double calWidth = width;
    double calHeight = 0;
    if (aqyAd) {
      IQYIOSExpressBannerAdType iqyIosExpressBannerAdType =
          IQYIOSExpressBannerAdType.values[adSizeIndex];
      switch (iqyIosExpressBannerAdType) {
        case IQYIOSExpressBannerAdType.AD_SIZE_FULLIMG:
          calWidth = width;
          calHeight = width / 2;
          break;
        case IQYIOSExpressBannerAdType.AD_SIZE_TITLEIN:
          calWidth = width;
          calHeight = width / 2;
          break;
        case IQYIOSExpressBannerAdType.AD_SIZE_TITLEAB:
          calWidth = width;
          calHeight = width / 750.0 * 552.0;
          break;
        case IQYIOSExpressBannerAdType.AD_SIZE_TITLEBL:
          calWidth = width;
          calHeight = width / 750.0 * 451.0;
          break;
        case IQYIOSExpressBannerAdType.AD_SIZE_STRIP:
          calWidth = width;
          calHeight = width / 640.0 * 120.0;
          break;
      }
    } else {
      IOSExpressBannerAdType bannerAdType =
          IOSExpressBannerAdType.values[adSizeIndex];
      switch (bannerAdType) {
        case IOSExpressBannerAdType.AD_SIZE_600X90:
          calWidth = 600;
          calHeight = 90;
          break;
        case IOSExpressBannerAdType.AD_SIZE_640X100:
          calWidth = 640;
          calHeight = 100;
          break;
        case IOSExpressBannerAdType.AD_SIZE_600X150:
          calWidth = 600;
          calHeight = 150;
          break;
        case IOSExpressBannerAdType.AD_SIZE_690X388:
          calWidth = 690;
          calHeight = 388;
          break;
        case IOSExpressBannerAdType.AD_SIZE_600X260:
          calWidth = 600;
          calHeight = 260;
          break;
        case IOSExpressBannerAdType.AD_SIZE_600X300:
          calWidth = 600;
          calHeight = 300;
          break;
        case IOSExpressBannerAdType.AD_SIZE_600X400:
          calWidth = 600;
          calHeight = 400;
          break;
        case IOSExpressBannerAdType.AD_SIZE_600X500:
          calWidth = 600;
          calHeight = 500;
          break;
      }
    }
    return Size(calWidth, calHeight);
  }

  @override
  Size getExpressBannerAdWidth(
      int adSizeIndex, double screenWidth, double marginSize, bool aqyAd) {
    Size calSize = _getSizeInner(adSizeIndex, screenWidth, aqyAd);
    double realWidth = screenWidth - marginSize * 2;
    double realHeight = calSize.height / calSize.width * realWidth;
    return Size(realWidth, realHeight);
  }
}
